<?php

include_once "phplib/db-str.php";

// List of versions that are planned...
$versions = array(
  "2.0"  => "The 2.0 series will focus on improving performance and "
	   ."adding user interface components where appropriate."
);

html_header("Development Roadmap");

html_start_links(1);
reset($versions);
while (list($version, $description) = each($versions))
  html_link("Newsd $version", "#$version");
html_end_links();

print("<h1>Development Roadmap</h1>\n"
     ."<p>This page provides a dynamic look at all Requests For Enhancement "
     ."(\"RFEs\") that have been filed and accepted through the <a href='str.php'>"
     ."Bugs &amp; Features</a> page. If you would like to contribute code to "
     ."implement any of the RFEs below, please post your changes to the "
     ."corresponding RFE.</p>\n");

$completed = 0;
$count     = 0;

reset($versions);
while (list($version, $description) = each($versions))
{
  $result = db_query("SELECT id, status FROM str WHERE "
                    ."str_version = '${version}-feature' "
                    ."AND priority = " . STR_PRIORITY_RFE
		    ." AND status != " . STR_STATUS_UNRESOLVED
		    ." AND status != " . STR_STATUS_NEW
		    ." ORDER BY id");

  if (db_count($result) > 0)
  {
    while ($row = db_next($result))
      if ($row["status"] == STR_STATUS_RESOLVED)
	$completed ++;

    $count   += db_count($result);
    $percent = (int)(100 * $completed / $count);

    print("<h2><a name='$version'>Newsd $version ($completed of $count "
         ."completed, $percent%)</a></h2>\n"
	 ."<p>$description</p>\n");

    html_start_table(array("STR #", "Summary", "Subsystem", "Status"));

    db_seek($result, 0);
    while ($row = db_next($result))
    {
      $id        = $row["id"];
      $str       = new str($id);
      $subsystem = htmlspecialchars($str->subsystem);
      $summary   = htmlspecialchars($str->summary);
      $status    = $STR_STATUS_SHORT[$str->status];

      html_start_row();
      print("<td align='center'><a href='str.php?L$id'>$id</a></td>"
           ."<td><a href='str.php?L$id'>$summary</a></td>"
           ."<td align='center'><a href='str.php?L$id'>$subsystem</a></td>"
           ."<td align='center'><a href='str.php?L$id'>$status</a></td>");
      html_end_row();
    }

    html_end_table();

    db_free($result);
  }
  else
    print("<h2><a name='$version'>Newsd $version (planned)</a></h2>\n"
	 ."<p>$description</p>\n");
}

html_footer();

?>
